###############################################################################
# Profile.pl                                                                  #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$profileplver = "1 Gold - SP 1.3";

sub ModifyProfile {
	if ($INFO{'username'} =~ m~/~){ &fatal_error($txt{'224'}); }
	if ($INFO{'username'} =~ m~\\~){ &fatal_error($txt{'225'}); }
	if($username ne $INFO{'username'} && $settings[7] ne 'Administrator') { &fatal_error($txt{'80'}); }
	if(!-e ("$memberdir/$INFO{'username'}.dat")){ &fatal_error("$txt{'453'} -- $INFO{'username'}"); }
	if($allowpics) {
		opendir(DIR, "$facesdir") || fatal_error("$txt{'230'} ($facesdir)! $txt{'681'}");
		closedir(DIR);
	}

	fopen(FILE, "$memberdir/$INFO{'username'}.dat");
	@memsettings=<FILE>;
	fclose(FILE);
	foreach (@memsettings) { $_ =~ s~[\n\r]~~g; }
	$dr = $memsettings[14] ? $memsettings[14] : $txt{'470'};
	if ($memsettings[11] eq 'Male') { $GenderMale = ' selected'; }
	if ($memsettings[11] eq 'Female') { $GenderFemale = ' selected'; }
	$signature = $memsettings[5];
	$signature =~ s/\&\&/\n/g;
	$signature =~ s/\&lt;/</g;
	$signature =~ s/\&gt;/>/g;
	&CalcAge("parse"); # Let's get the birthdate
	$memsettings[9] =~ tr/+/ /;
	$memsettings[10] =~ tr/+/ /;

	unless ($smart_date_disable_profile)
	{
		if ($memsettings[17] == 8) { $tsl8 = ' selected'; }
		elsif ($memsettings[17] == 7) { $tsl7 = ' selected'; }
		elsif ($memsettings[17] == 6) { $tsl6 = ' selected'; }
		elsif ($memsettings[17] == 5) { $tsl5 = ' selected'; }
		elsif ($memsettings[17] == 4) { $tsl4 = ' selected'; }
		elsif ($memsettings[17] == 3) { $tsl3 = ' selected'; }
		elsif ($memsettings[17] == 2) { $tsl2 = ' selected'; }
		elsif ($memsettings[17] == 1) { $tsl1 = ' selected'; }
		elsif ($timeselected == 8) { $tsl8 = ' selected'; }
		elsif ($timeselected == 7) { $tsl7 = ' selected'; }
		elsif ($timeselected == 6) { $tsl6 = ' selected'; }
		elsif ($timeselected == 5) { $tsl5 = ' selected'; }
		elsif ($timeselected == 4) { $tsl4 = ' selected'; }
		elsif ($timeselected == 3) { $tsl3 = ' selected'; }
		elsif ($timeselected == 2) { $tsl2 = ' selected'; }
		else { $tsl1 = ' selected'; }
	}

	$dayormonthm = qq~$txt{'564'}<input type="text" name="bday1" size="2" maxlength="2" value="$umonth">~; $dayormonthd = qq~$txt{'565'}<input type="text" name="bday2" size="2" maxlength="2" value="$uday">~;
	if ($tsl2 || $tsl3 || $tsl6) {$dayormonth=$dayormonthd.$dayormonthm;} else {$dayormonth=$dayormonthm.$dayormonthd;}

	$oldformat = $date;
	$oldmonth = substr($oldformat,0,2);
	$oldday = substr($oldformat,3,2);
	$oldyear = ("20".substr($oldformat,6,2)) - 1900;
	$oldhour = substr($oldformat,-8,2);
	$oldminute = substr($oldformat,-5,2);
	$oldsecond = substr($oldformat,-2,2);
	use Time::Local 'timelocal';
	eval { $oldtime = timelocal($oldsecond,$oldminute,$oldhour,$oldday,$oldmonth-1,$oldyear); };
	my ($psec,$pmin,$phour,$dummy,$dummy,$dummy,$dummy,$dummy,$dummy) = localtime($oldtime);
	if ($phour < 10) { $phour = "0$phour" };
	if ($pmin < 10) { $pmin = "0$pmin" };
	if ($psec < 10) { $psec = "0$psec" };
	$proftime = $phour.":".$pmin.":".$psec;
	$ampm = $phour > 11 ? 'pm' : 'am';
	$phour = $phour % 12 || 12;
	$proftime = qq~$phour:$pmin:$psec$ampm~;
	my( @imconfig, $sel0, $sel1 );
	if (-e("$memberdir/$INFO{'username'}.imconfig")) {
		fopen(FILE, "$memberdir/$INFO{'username'}.imconfig");
		@imconfig = <FILE>;
		fclose(FILE);
	}
	$imconfig[0] =~ s/[\n\r]//g;
	$imconfig[0] =~ s/\|/\n/g;
	$imconfig[1] =~ s/[\n\r]//g;
	if ($imconfig[1]) {
		$sel0='';
		$sel1=' selected';
	} else {
		$sel0=' selected';
		$sel1='';
	}

	$yymain .= qq~
<form action="$cgi;action=profile2" method="POST" name="creator">
<table border=0 width=720 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" height="30">
    &nbsp;<img src="$imagesdir/profile.gif" alt="" border="0">&nbsp;
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'79'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" height="25"><BR><font size="1">$txt{'698'}</font><BR><BR><a href="$scripturl?action=travelmap1">$TravelMaptxt{'04'}</a><br><br></td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'517'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <table border=0 width="100%" cellpadding="3">
      <tr>
	<td width="320"><font size=2><b>$txt{'35'}: </b></font></td>
	<td><font size=2><input type="hidden" name="username" value="$INFO{'username'}">$INFO{'username'}</font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'81'}: </b></font><BR>
	<font size="1">$txt{'596'}</font></td>
	<td><input type="password" maxlength="30" name="passwrd1" size="20" value="$memsettings[0]"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'82'}: </b></font></td>
	<td><input type="password" maxlength="30" name="passwrd2" size="20" value="$memsettings[0]"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'68'}: </b></font><BR>
	<font size="1">$txt{'518'}</font></td>
	<td><input type="text" maxlength="30" name="name" size="30" value="$memsettings[1]"></td>
      </tr><tr>
	<td width="320"><font size="2"><b>$txt{'69'}: </b></font><br>
        <font size="1">$txt{'679'}</font></td>
	<td><input type="text" maxlength="40" name="email" size="30" value="$memsettings[2]"></td>
      </tr>
      <tr>
        <td width="320"><font size=2><b>$pwtxt{'755'}: </b></font><BR>
        <font size="1">$pwtxt{'756'}</font></td>
        <td><input type="text" name="secretquestion" size="30" value="$memsettings[20]"></td>
      </tr><tr>
        <td width="320"><font size=2><b>$pwtxt{'757'}: </b></font><BR></td>
        <td><input type="password" name="secretanswer" size="30" value="$memsettings[21]"></td>
      </tr>
    </table><br>
    </font></td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'597'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <table border=0 width="100%" cellpadding="3">
      <tr>
	<td width="320"><font size=2><b>$txt{'231'}: </b></font></td>
	<td>
	<select name="gender" size="1">
	 <option value=""></option>
	 <option value="Male"$GenderMale>$txt{'238'}</option>
	 <option value="Female"$GenderFemale>$txt{'239'}</option>
	</select>
	</td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'563'}:</b></font></td>
	<td><font size="1">$dayormonth$txt{'566'}<input type="text" name="bday3" size="4" maxlength="4" value="$uyear"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'227'}: </b></font></td>
	<td><font size=2><input type="text" maxlength="30" name="location" size="50" value="$memsettings[15]"></font></td>
      </tr><tr>
	<td colspan=2>
	<BR><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'83'}: </b></font><BR>
	<font size="1">$txt{'598'}</font></td>
	<td><font size=2><input type=text maxlength="30" name=websitetitle size=50 value="$memsettings[3]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'84'}: </b></font><BR>
	<font size="1">$txt{'599'}</font></td>
	<td><font size=2><input type=text name=websiteurl size=50 value="$memsettings[4]"></font></td>
      </tr><tr>
	<td colspan=2>
	<BR><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'513'}: </b></font><BR>
	<font size="1">$txt{'600'}</font></td>
	<td><font size=2><input type=text maxlength="10" name=icq size=20 value="$memsettings[8]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'603'}: </b></font><BR>
	<font size="1">$txt{'601'}</font></td>
	<td><font size=2><input type=text maxlength="30" name=aim size=20 value="$memsettings[9]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'604'}: </b></font><BR>
	<font size="1">$txt{'602'}</font></td>
	<td><font size=2><input type=text maxlength="30" name=yim size=20 value="$memsettings[10]"></font></td>
      </tr><tr>
	<td colspan=2>
	<BR><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'228'}: </b></font></td>
	<td><font size=2><input type=text name=usertext size=50 value="$memsettings[12]" maxlength="50"></font></td>
      </tr>
~;
	if($allowpics) {
		opendir(DIR, "$facesdir") || fatal_error("$txt{'230'} ($facesdir)!<BR>$txt{'681'}");
		@contents = readdir(DIR);
		closedir(DIR);
		$images = "";
		foreach $line (sort @contents){
			($name, $extension) = split (/\./, $line);
			$checked = "";
			if ($line eq $memsettings[13]) { $checked = ' selected'; }
			if ($memsettings[13] =~ m~\Ahttp://~ && $line eq 'blank.gif') { $checked = ' selected'; }
			if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){
				if ($line eq 'blank.gif') { $name = $txt{'422'}; }
				$images .= qq~<option value="$line"$checked>$name\n~;
			}
		}
		if ($memsettings[13] =~ m~\Ahttp://~) {
			$pic = 'blank.gif';
			$checked = ' checked';
			$tmp = $memsettings[13];
		}
		else {
			$pic = $memsettings[13];
			$tmp = 'http://';
		}
		if (-e "$memberdir/$INFO{'username'}.siz") {
			fopen(FILE, "$memberdir/$INFO{'username'}.siz");
			@imagsize=<FILE>;
			fclose(FILE);
			foreach (@imagsize) { $_ =~ s~[\n\r]~~g; }
			$akt_width = $imagsize[0];
			$akt_height = $imagsize[1];
		}
		else {
			$akt_width = 65;
			$akt_height = 65;
		}

		$yymain .= qq~
      <tr>
	<td width="320"><font size="2"><b>$txt{'229'}:</b></font><br>
	<font size="1">$txt{'474'} $userpic_limits</font></td>
        <td>
        <script language="JavaScript1.2" type="text/javascript">
        function showimage()
        {
           if (!document.images) return;
           document.images.icons.src="$facesurl/"+document.creator.userpic.options[document.creator.userpic.selectedIndex].value;
        }
        </script>
        <select name="userpic" size=6 onChange="showimage()">$images</select>
        &nbsp;&nbsp;<img src="$facesurl/$pic" name="icons" border=0 hspace=15>
	</td>
      </tr><tr>
	<td width="320"><font size="2"><B>$txt{'475'}</B></font></td>
	<td><input type="checkbox" name="userpicpersonalcheck"~;
#### Start Upload Avatar Mod ####
	if(-e "$umauploaddir/$INFO{'username'}.tmp") {
		$checked="checked";

		fopen(FILE, "$umauploaddir/$INFO{'username'}.tmp");
		@Aupltmp=<FILE>;
		fclose(FILE);
		$tmp=$Aupltmp[0];
		unlink("$umauploaddir/$INFO{'username'}.tmp");
	}		
	$yymain .= qq~$checked><input type="text" name="userpicpersonal" size="45" value="$tmp"></td>
      </tr>~;

	if($allowuplava) {
		$yymain .= qq~
      <tr>
	<td><font size="2"><B>$uplavatxt{'1'}:</B></font><br><font size="1">$uplavatxt{'2'} <b>$uplavasize kB</b>.</font></td>
	<td valign="top"><input type="button" value="$uplavatxt{'1'}" onClick="self.location.href='$boardurl/YaBB.$yyext?board=;action=uploadavatar;username=$INFO{'username'}'"></td>
      </tr>
	<tr>
	<td width="320"> <font size="2"><B>$siztxt{'01'}</B></font> </td>
	<td>
	<input type="text" name="aktwidth" size="5" value="$akt_width"><font size="2"><B> x </B></font>
	<input type="text" name="aktheight" size="5" value="$akt_height"><font size="2"><B> pixel</B></font>
	</td>
      </tr>~;
}
#### End Upload Avatar Mod ####
	}
	$yymain .= qq~
    </table><BR>
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$imtxt{'38'}</b></font></td><a name="userimcfg">
  </tr><tr>
  <td class="windowbg" bgcolor="$color{'windowbg'}">
    <table border=0>
     <tr>
      <td valign=top>
       <font size=2><b>$txt{'325'}:</b></font><br><font size="1">$txt{'326'}</font>
      </td>
      <td>
       <font size=2><textarea name=ignore rows=4 cols=50 wrap=virtual>$imconfig[0]</textarea></font>
      </td>
     </tr>~;
	if($enable_mailsounds) {
		# sounds hack
		chomp($imconfig[2]);

		opendir(DIR, "$soundsdir") || fatal_error("$txt{'230'} ($soundsdir)!<BR>$imtxt{'27'}");
		@contents = readdir(DIR);
		closedir(DIR);
		$sounds = "";
		if ($imconfig[2] eq "blank.wav" || $imconfig[2] eq "") { $sounds = qq~<option value="blank.wav"$checked selected>$imtxt{'28'}\n~; }
		else { $sounds = qq~<option value="blank.wav"$checked>$imtxt{'28'}\n~; }
		foreach $line (sort @contents) {
			chomp($line);
			($name, $extension) = split (/\./, $line);
			$checked = "";
			if ($line eq "$imconfig[2]") { $checked = ' selected'; }
				if($extension =~ /wav/i) {
				$sounds .= qq~<option value="$line"$checked>$name\n~;
				}
			}
	$yymain .= qq~
<bgsound id="sound">
<script language="JavaScript1.2" type="text/javascript">
<!--
function playSound() { document.all.sound.src = "$soundsurl/"+document.all.usersound.options[document.all.usersound.selectedIndex].value; }
//-->
</script>	
		<tr><td width="320"><font size=2><b>$imtxt{'29'}:</b></font></td><td><select name="usersound" size="4" onChange="playSound()">$sounds</select></td></tr>~;
	} else { $yymain .= qq~<input type=hidden name="usersound" value="$imconfig[2]">~; }
if($enable_notification) {
	$yymain .= qq~
     <tr>
      <td valign=top>
       <font size=2><b>$txt{'327'}:</b></font>
      </td>
      <td>
       <font size=2>
	<select name="notify">
	 <option value="0"$sel0>$txt{'164'}
	 <option value="1"$sel1>$txt{'163'}
	</select>
       </font>
      </td>
     </tr>
~;
} else { $yymain .= qq~<input type=hidden name="notify" value="$imconfig[1]">~; }

	chomp($imconfig[4]);
	if($imconfig[4] eq "on") { $enable_imprev = 'checked'; }
	$yymain .= qq~<tr><td width="320"><font size=2><b>$imtxt{'51'}:</b></font></td><td><input type=checkbox name="imprev" $enable_imprev></td></tr>~;

	if($enable_mailpopup) {
	chomp($imconfig[3]);
	chomp($imconfig[5]);
	if($imconfig[3] eq "on") { $enable_userimpopup = 'checked'; }
	if($imconfig[5] eq "on") { $popup_userim = 'checked'; }
	$yymain .= qq~  <tr><td width="320"><font size=2><b>$imtxt{'05'}:</b></font></td><td><input type=checkbox name="userpopup" $enable_userimpopup></td></tr>
			<tr><td width="320"><font size=2><b>$imtxt{'53'}:</b></font></td><td><input type=checkbox name="popupims" $popup_userim></td></tr>~;
	} else { $yymain .= qq~ <input type=hidden name="userpopup" value="$imconfig[3]">
				<input type=hidden name="popupims" value="$imconfig[5]">~; }
chomp($imconfig[6]);
$imconfig[7] =~ s~<br>~\n~ig;
if($imconfig[6] eq "on") { $send_away_im = 'checked'; }
$yymain .= qq~  <tr><td width="320"><font size=2><b>$imtxt{'80'}</b></font></td><td><input type=checkbox name="sendaim" $send_away_im></td></tr>
     <tr>
      <td valign=top>
       <font size=2><b>$imtxt{'82'}</b></font><br><font size="1">$imtxt{'81'}</font>
      </td>
      <td>
       <font size=2><textarea name=awayim rows=4 cols=50 wrap=virtual>$imconfig[7]</textarea></font>
      </td>
     </tr>
    </table><BR>
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25"><font size=2><b>$txt{'605'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <table border=0 cellpadding="3" width="100%" cellspacing="0">
~;
	if ($allow_hide_email) {
		$yymain .= qq~
    <tr>
	<td width="320"><font size=2><b>$txt{'721'}</b></font></td>
	<td><input type="checkbox" name="hideemail" value="checked" $memsettings[19]></td>
    </tr>
~;
	}
	$yymain .= qq~
	~;

	if ($smart_date_disable_profile)
	{
		$yymain .= qq~<input type="hidden" name="usertimeselect" value="$memsettings[17]"><tr>~;
	}
	else
	{
		$yymain .= qq~
	<tr>
	<td width="320"><font size=2><b>$txt{'486'}:</b></font><BR>
	<font size="1">$txt{'479'}</font></td>
	<td width="50">
	<select name="usertimeselect" size="1">
	<option value="1"$tsl1>$txt{'480'}</option>
	<option value="2"$tsl2>$txt{'481'}</option>
	<option value="3"$tsl3>$txt{'482'}</option>
	<option value="6"$tsl6>$txt{'485'}</option>
	<option value="4"$tsl4>$txt{'483'}</option>
	<option value="8"$tsl8>$smart_dates{'6'}</option>
	<option value="5"$tsl5>$txt{'484'}</option>
	<option value="7"$tsl7>$smart_dates{'4'}</option>
	</select>
	</td>
      </tr><tr>
~;
	}

	$yymain .= qq~
	<td width="320"><font size=2><b>$txt{'371'}:</b></font><BR>
	<font size="1">$txt{'519'}</font></td>
	<td><font size="1">
	<input name="usertimeoffset" size="5" maxlength="5" value="$memsettings[18]">
	<BR>$txt{'741'}: <i>$proftime</i></font></td>
      </tr><tr>
		<td colspan=2><br><hr width="100%" size="1" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'85'}:</b></font><BR>
	<font size="1">$txt{'606'}</font></td>
	<td><font size=2><textarea name="signature" rows="4" cols="50" wrap="virtual">$signature</textarea><BR>
	<font size="1">$txt{'664'} <input value="$MaxSigLen" size="3" name="msgCL" disabled></FONT><BR><BR></font></td></tr>
	<script language="JavaScript">
	<!--
	var supportsKeys = false
	function tick() {
	  calcCharLeft(document.forms[0])
	  if (!supportsKeys) timerID = setTimeout("tick()",$MaxSigLen)
	}

	function calcCharLeft(sig) {
	  clipped = false
	  maxLength = $MaxSigLen
	  if (document.creator.signature.value.length > maxLength) {
		document.creator.signature.value = document.creator.signature.value.substring(0,maxLength)
		charleft = 0
		clipped = true
	  } else {
		charleft = maxLength - document.creator.signature.value.length
	  }
	  document.creator.msgCL.value = charleft
	  return clipped
	}

	tick();
	//-->
	</script>
~;
if($settings[7] eq "Administrator") {
		if($memsettings[7] eq 'Administrator') { $tt2 = $MemStatAdmin; $tt = "Administrator"; }
		elsif ($memsettings[7] eq 'Global Moderator') { $tt2 = $MemStatGMod; $tt = "Global Moderator"; }
		else { $tt = $memsettings[7]; $tt2 = $memsettings[7]; }
	$yymain .= qq~
      <tr>
	<td colspan=2><HR size=1 width="100%" class="hr"></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'86'}: </b></font></td>
	<td><font size=2><input type=text name=settings6 size=4 value="$memsettings[6]"></font></td>
      </tr><tr>
	<td width="320"><font size=2><b>$txt{'87'}: </b></font></td>
	<td><font size=2><select name="settings7">
	 <option value="$tt">$tt2
	 <option value="$tt">---------------
	 <option value="">
~;
		$position='';
		$z=0;
	 $yymain .= qq~<option value="Administrator">$MemStatAdmin~;
	 $yymain .= qq~<option value="Global Moderator">$MemStatGMod~;
	 $yymain .= qq~<option value="$MemStatNewbie">$MemStatNewbie~;
		while($MemStat[$z]) {
			$position= qq~<option value="$MemStat[$z]">$MemStat[$z]~;
			++$z;
		$yymain .= qq~$position~;
}
		$yymain .= qq~
	</select></font></td>
      </tr><tr>
        <td width="320"><font size="2"><b>$txt{'233'}:</b><br>
        <font size=1>$txt{'421'}</font></td>
        <td><input type="text" name="dr" size="20" value="$dr"></td></tr>
~;
}
	$yymain .= qq~
    </table>
    </font></td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25" align="center"><font size=2><BR>
    <input type=submit name=moda value="$txt{'88'}">
    <input type=submit name=moda value="$txt{'89'}" onClick="return confirm('$confdel_text')"><BR><BR>
    </font></td>
  </tr>
</table>
</form>
~;
	$yytitle = $txt{'79'};
	&template;
	exit;
}

sub ModifyProfile2 {
	my( $ignorelist, $notify, $sound, $popup, $imprev, $imspop, $enableaim, $awayim);
	$ignorelist = "$FORM{'ignore'}";
	$notify = "$FORM{'notify'}";
	$sound = "$FORM{'usersound'}";
	$popup = "$FORM{'userpopup'}";
	$imprev = "$FORM{'imprev'}";
	$imspop = "$FORM{'popupims'}";
	$awayim = "$FORM{'awayim'}";
	$enableaim = "$FORM{'sendaim'}";

	$ignorelist =~ s~\A\n\s*~~;
	$ignorelist =~ s~\s*\n\Z~~;
	$ignorelist =~ s~\n\s*\n~\n~g;
	$ignorelist =~ s~[\n\r]~\|~g;
	$ignorelist =~ s~\|\|~\|~g;
	$notify =~ s~[\n\r]~~g;
	$sound =~ s~[\n\r]~~g;
	$popup =~ s~[\n\r]~~g;
	$imprev =~ s~[\n\r]~~g;
	$imspop =~ s~[\n\r]~~g;
	$enableaim =~ s~[\n\r]~~g;
	$awayim =~ s~[\n]~<BR>~g;
	my( %member, $key, $value, $newpassemail, @memberlist, $a, @check_settings, @reserve, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, @dirdata, $filename, @entries, $entry, $umail, @members, $tempname );
	$FORM{'signature'} =~ s~\n~\&\&~g;
	while( ($key,$value) = each(%FORM) ) {
		$value =~ s~\A\s+~~;
		$value =~ s~\s+\Z~~;
		$value =~ s~[\n\r]~~g;
		$member{$key} = $value;
	}

	# make sure this person has access to this profile
	if($username ne $member{'username'} && $settings[7] ne 'Administrator') { &fatal_error($txt{'80'}); }
	if( $settings[7] ne 'Administrator' ) {
		$member{'username'} = $username;
		$member{'settings6'} = $settings[6];
		$member{'settings7'} = $settings[7];
	}
	if($member{'settings6'} !~ /\A[0-9]+\Z/) { &fatal_error("$txt{'749'}"); }
	if ($member{'username'} =~ /\//){ &fatal_error($txt{'224'}); }
	if ($member{'username'} =~ /\\/){ &fatal_error($txt{'225'}); }
	$INFO{'username'} = $member{'username'};
	if(length($member{'usertext'}) > 71) { &fatal_error("$txt{'757'}"); }
	if( $member{'userpicpersonalcheck'} && ( $member{'userpicpersonal'} =~ m/\.gif\Z/i || $member{'userpicpersonal'} =~ m/\.jpg\Z/i || $member{'userpicpersonal'} =~ m/\.jpeg\Z/i || $member{'userpicpersonal'} =~ m/\.png\Z/i ) ) {
		$member{'userpic'} = $member{'userpicpersonal'};
	}
	if($member{'userpic'} eq "") { $member{'userpic'} = "blank.gif"; }
	&fatal_error("$txt{'592'}") if($member{'userpic'} !~ m^\A[0-9a-zA-Z_\.\#\%\-\:\+\?\$\&\~\.\,\@/]+\Z^);
	if($FORM{'aktwidth'} !~ /\A[0-9]+\Z/) { &fatal_error("$siztxt{'02'}"); }
	if($FORM{'aktheight'} !~ /\A[0-9]+\Z/) { &fatal_error("$siztxt{'03'}"); }
	if($FORM{'aktwidth'} < 1) { &fatal_error("$siztxt{'02'}"); }
	if($FORM{'aktheight'} < 1) { &fatal_error("$siztxt{'03'}"); }
	if(!$allowpics) { $member{'userpic'} = "blank.gif"; }
	if( $emailnewpass && lc $member{'email'} ne lc $settings[2] && $settings[7] ne 'Administrator') {
		srand();
		$member{'passwrd1'} = int( rand(100) );
		$member{'passwrd1'} =~ tr/0123456789/ymifxupbck/;
		$_ = int( rand(77) );
		$_ =~ tr/0123456789/q8dv7w4jm3/;
		$member{'passwrd1'} .= $_;
		$_ = int( rand(89) );
		$_ =~ tr/0123456789/y6uivpkcxw/;
		$member{'passwrd1'} .= $_;
		$_ = int( rand(188) );
		$_ =~ tr/0123456789/poiuytrewq/;
		$member{'passwrd1'} .= $_;
		$_ = int( rand(65) );
		$_ =~ tr/0123456789/lkjhgfdaut/;
		$member{'passwrd1'} .= $_;
		$newpassemail = 1;
	} else {
		&fatal_error("($member{'username'}) $txt{'213'}") if($member{'passwrd1'} ne $member{'passwrd2'});
		&fatal_error("($member{'username'}) $txt{'91'}") if($member{'passwrd1'} eq '');
		&fatal_error("$txt{'240'} $txt{'36'} $txt{'241'}") if($member{'passwrd1'} !~ /\A[\s0-9A-Za-z!@#$%\^&*\(\)_\+|`~\-=\\:;'",\.\/?\[\]\{\}]+\Z/);
	}
	&fatal_error("$txt{'75'}") if($member{'name'} eq '');
	&fatal_error("$txt{'240'} $txt{'68'} $txt{'241'}") if($member{'name'} !~ /^[\s0-9A-Za-z\[\]#%+,-|\.:=?@^_]+$/);
	&fatal_error("$txt{'75'}") if($member{'name'} eq '|');
	&fatal_error("$txt{'568'}") if(length($member{'name'}) > 30);
	&fatal_error("$txt{'76'}") if($member{'email'} eq '');
	&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($member{'email'} !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/);
	&fatal_error("$txt{'500'}") if(($member{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($member{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	&fatal_error("$pwtxt{'758'}") if($member{'secretquestion'} eq '');
	&fatal_error("$pwtxt{'759'}") if($member{'secretanswer'} eq '');
	if( $member{'bday1'} ne "" || $member{'bday2'} ne "" || $member{'bday3'} ne "" ) {
		&fatal_error("$txt{'567'}") if( $member{'bday1'} !~ /^[0-9]+$/ || $member{'bday2'} !~ /^[0-9]+$/ || $member{'bday3'} !~ /^[0-9]+$/ || length($member{'bday3'}) < 4 );
		&fatal_error("$txt{'567'}") if( $member{'bday1'} < 1 || $member{'bday1'} > 12 || $member{'bday2'} < 1 || $member{'bday2'} > 31 || $member{'bday3'} < 1901 || $member{'bday3'} > $year-5 );
	}
	&fatal_error("$txt{'680'}") if ($member{'username'} eq "admin" && $member{'settings7'} ne "Administrator");

	if($member{'moda'} eq $txt{'88'}) {
		if (length($member{'signature'}) > $MaxSigLen) { $member{'signature'} = substr($member{'signature'},0,$MaxSigLen); }
	        $member{'icq'} =~ s/[^0-9]//g;
		$member{'bday1'} =~ s/[^0-9]//g;
	        $member{'bday2'} =~ s/[^0-9]//g;
		$member{'bday3'} =~ s/[^0-9]//g;
		if($member{'bday1'}) { $member{'bday'} = "$member{'bday1'}/$member{'bday2'}/$member{'bday3'}"; }
		else { $member{'bday'} = ''; }
		$member{'signature'} =~ s/</&lt;/g;
	        $member{'signature'} =~ s/</&gt;/g;
	        $member{'aim'} =~ s/ /\+/g;
	        $member{'yim'} =~ s/ /\+/g;
		if($settings[7] ne "Administrator") { $member{'dr'} = $settings[14]; }
		# store the name temorarily so we can restore any _'s later
		$tempname = $member{'name'};
		$member{'name'} =~ s/\_/ /g;

		&ToHTML($member{'location'});
		&ToHTML($member{'aim'});
		&ToHTML($member{'yim'});
		&ToHTML($member{'gender'});
		&ToHTML($member{'usertext'});
		&ToHTML($member{'websiteurl'});
		&ToHTML($member{'websitetitle'});
		&ToHTML($member{'email'});
		&ToHTML($FORM{'hideemail'});
		&ToHTML($member{'name'});

		&FromHTML($member{'usertext'});
		$member{'usertext'} =~ s~(\S{15})(?=\S)~$1 ~g;
		&ToHTML($member{'usertext'});

		if ( length $member{'signature'} > 1000 ) { $member{'signature'} = substr( $member{'signature'}, 0, 1000 ); }
		$member{'usertimeoffset'} =~ tr/,/./;
		$member{'usertimeoffset'} =~ s/[^\d*|\.|\-|w*]//g;
		if (( $member{'usertimeoffset'} < -23.5) || ( $member{'usertimeoffset'} > 23.5)) { &fatal_error($txt{'487'}); }

		fopen(FILE, "$memberdir/memberlist.txt");
		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $member{'name'};
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				# Load users and check email (removed !$yyUDLoaded{$memberlist[$a]} && )
				if( -e("$memberdir/$memberlist[$a].dat") && lc $memberlist[$a] ne lc $member{'username'}) {
					# If user is not in memory, s/he must be loaded.
					&LoadUser($memberlist[$a]);
					if(lc $userprofile{$memberlist[$a]}->[2] eq lc $member{'email'}) { &fatal_error("$txt{'730'} ($member{'email'}) $txt{'731'}"); }
				}
				$tmpa = <FILE2>;
				$realnametemp = <FILE2>;
				fclose(FILE2);
				chomp $realnametemp;
				$realnametemp = lc $realnametemp;
				if ($realnametemp eq $testname && lc $memberlist[$a] ne lc $member{'username'} && $settings[7] ne 'Administrator') { &fatal_error("($member{'name'}) $txt{'473'}"); }
			}
		}

		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("$txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("$txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for($a = 0; $a < @reservecfg; $a++) { chomp $reservecfg[$a]; }
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $member{'name'} : lc $member{'name'};

		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
$member{'aktwidth'} = $FORM{'aktwidth'};
$member{'aktheight'} = $FORM{'aktheight'};
fopen( FILE, ">$memberdir/$member{'username'}.siz", 1);
print FILE "$member{'aktwidth'}\n";
print FILE "$member{'aktheight'}\n";
fclose(FILE);

		# let's restore the name now
		&ToHTML($tempname);
		$member{'name'} = $tempname;

		fopen(MEMBERFILEREAD,"$memberdir/$member{'username'}.dat");
		my @memset = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		chomp @memset;
		require "$sourcedir/Notify.pl";
		replace_notifications($memset[2],$member{'email'});

                fopen(SETTINGS, "$memberdir/$member{'username'}.dat");
                @userProfileSettings = <SETTINGS>;
                fclose(SETTINGS);
                chomp $userProfileSettings[0];
                chomp $userProfileSettings[21];

                if ($member{'passwrd1'} eq $userProfileSettings[0]) {

			$cryptpass = $member{'passwrd1'};
		}
		else {
			$cryptpass = crypt("$member{'passwrd1'}",$pwseed);
		}
                if ($member{'secretanswer'} eq $userProfileSettings[21]) {
                        $cryptanswer = $member{'secretanswer'};
		}
                else {
                        $cryptanswer = crypt("$member{'secretanswer'}",$pwseed);
		}

		fopen(FILE, "+>$memberdir/$member{'username'}.imconfig");
		print FILE "$ignorelist\n$notify\n$sound\n$popup\n$imprev\n$imspop\n$enableaim\n$awayim";
		fclose(FILE);
		fopen( FILE, ">$memberdir/$member{'username'}.dat", 1);
		print FILE "$cryptpass\n";
		print FILE "$member{'name'}\n";
		print FILE "$member{'email'}\n";
		print FILE "$member{'websitetitle'}\n";
		print FILE "$member{'websiteurl'}\n";
		print FILE "$member{'signature'}\n";
		print FILE "$member{'settings6'}\n";
		print FILE "$member{'settings7'}\n";
		print FILE "$member{'icq'}\n";
		print FILE "$member{'aim'}\n";
		print FILE "$member{'yim'}\n";
		print FILE "$member{'gender'}\n";
		print FILE "$member{'usertext'}\n";
		print FILE "$member{'userpic'}\n";
		print FILE "$member{'dr'}\n";
		print FILE "$member{'location'}\n";
		print FILE "$member{'bday'}\n";
		print FILE "$member{'usertimeselect'}\n";
		print FILE "$member{'usertimeoffset'}\n";
		if ($FORM{'hideemail'} ne "checked") { $FORM{'hideemail'} = ""; }
		print FILE "$FORM{'hideemail'}\n";
		print FILE "$member{'secretquestion'}\n";
		print FILE "$cryptanswer\n";
		fclose(FILE);

	if($memset[7] ne "$member{'settings7'}") { require "$sourcedir/MemberGroups.pl"; &RebuildMemGroup; }
	if($newpassemail) {

	# Write log
	fopen(LOG, "$vardir/log.txt");
	@entries = <LOG>;
	fclose(LOG);
	fopen(LOG, ">$vardir/log.txt", 1);
	$field="$username";
	foreach $curentry (@entries) {
	        $curentry =~ s/\n//g;
     		($name, $value) = split(/\|/, $curentry);
	        if($name ne "$field") {
	                print LOG "$curentry\n";
	        }
	}
	fclose(LOG);

	$yySetCookies1 = cookie(-name    =>   "$cookieusername",
				-value   =>   "",
				-path    =>   "/",
				-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
	$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
				-value   =>   "",
				-path    =>   "/",
				-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
	$username = 'Guest';
	$password = '';
	@settings = ();
	$realname = '';
	$realemail = '';
	$ENV{'HTTP_COOKIE'} = '';
	&FormatUserName($member{'username'});
	&sendmail($member{'email'},qq~$txt{'700'} $mbname~, "$txt{'733'} $member{'passwrd1'} $txt{'734'} $member{'username'}.\n\n$txt{'701'} $scripturl?action=profile;username=$useraccount{$member{'username'}}\n\n$txt{'130'}");
	$yymain .= qq~<br><table border="0" width="100%" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">~;

	require "$sourcedir/LogInOut.pl";
	$sharedLogin_title="$txt{'34'}";
	$sharedLogin_text="$txt{'638'}";
	&sharedLogin;

	$yymain .= qq~</table>~;
	$yytitle="$txt{'245'}";
	&template;
	exit;
	}
	else {
		if ($member{'username'} eq $username) {
			$password = $cryptpass;
			$yySetCookies1 = cookie(-name    =>   "$cookieusername",
						-value   =>   "$username",
						-path    =>   "/",
						-expires =>   "Sunday, 17-Jan-2038 00:00:00 GMT");
			$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
						-value   =>   "$password",
						-path    =>   "/",
						-expires =>   "Sunday, 17-Jan-2038 00:00:00 GMT");
			&LoadUserSettings;
			&WriteLog;
		}
		&ViewProfile;
	}
	} else {
	if($member{'username'} ne "admin") {
		require "$sourcedir/Notify.pl";
		remove_notifications($member{'email'});

	# For security, remove username from mod position
	fopen(FILE, "$vardir/cat.txt"); @categories = <FILE>; fclose(FILE);

	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		fopen(CAT, "$boardsdir/$curcat.cat"); @catinfo = <CAT>; fclose(CAT);

		foreach $curboard (@catinfo) {
				$curboard =~ s/[\n\r]//g; chomp $curboard;

				fopen(BOARD, "$boardsdir/$curboard.dat"); @boardinfo = <BOARD>; fclose(BOARD);

				$boardinfo[2] =~ s/[\n\r]//g; $boardinfo[2] =~ /^\|(.*?)\|$/;
				$mods = $1 or $mods = $boardinfo[2];
                                $mods =~ s/(\s*)//g;              # remove all whitespaces
				$mods =~ s/(^(\|)+)?((\|)+$)?//;  # remove unnecessary front and back separator
				$mods =~ s/(\|)+/\|/g;            # replace multiple separators with one separator

				my @mod_ary = split(/\|/, $mods);
				my @new_mod_ary;
				my $mods_changed = 0;
				foreach my $mod( @mod_ary) {
					if( $settings[7] eq 'Administrator') {
						if( $member{'username'} ne $mod) {
							push( @new_mod_ary, $mod);
						} else {
							$mods_changed = 1;
						}
					} elsif( $member{'username'} eq $username) {
						if( $username ne $mod) {
							push( @new_mod_ary, $mod);
						} else {
							$mods_changed = 1;
						}
					}
				}				
				$mods = join( "|", @new_mod_ary);

				if ($mods_changed == 1)
				{
					$boardinfo[2] = $mods;
					fopen(BOARD, ">$boardsdir/$curboard.dat", 1);
					print BOARD @boardinfo;
					fclose(BOARD);
				}
		}
	}
		if($settings[7] eq 'Administrator') {
			unlink("$memberdir/$member{'username'}.home");
			unlink("$memberdir/$member{'username'}.dat");
			unlink("$memberdir/$member{'username'}.msg");
			unlink("$memberdir/$member{'username'}.log");
	                unlink("$memberdir/$member{'username'}.outbox");
	                unlink("$memberdir/$member{'username'}.imconfig");
			if(-e "$memberdir/$member{'username'}.mim") {
	                unlink("$memberdir/$member{'username'}.mim");
			}
	                if (-e "$memberdir/$member{'username'}.siz") { unlink("$memberdir/$member{'username'}.siz"); }
	if(-e "$memberdir/$member{'username'}.pop") {
		unlink("$memberdir/$member{'username'}.pop");
	}
	                unlink("$memberdir/$member{'username'}.yam");
			if(-e "$memberdir/$member{'username'}.bud") {
	                unlink("$memberdir/$member{'username'}.bud");
			}
	                unlink("$memberdir/$member{'username'}.ll");
	                unlink("$memberdir/$member{'username'}.buddy");
	                unlink("$memberdir/$member{'username'}.storage");
		}
		elsif( $member{'username'} eq $username ) {
			unlink("$memberdir/$username.home");
			unlink("$memberdir/$username.dat");
			unlink("$memberdir/$username.msg");
			unlink("$memberdir/$username.log");
			if (-e("$memberdir/$username.tmap"))  { unlink("$memberdir/$username.tmap"); }
	                unlink("$memberdir/$username.outbox");
	                unlink("$memberdir/$username.imconfig");
			if(-e "$memberdir/$username.mim") {
	                unlink("$memberdir/$username.mim");
			}
	                if (-e "$memberdir/$username.siz") { unlink("$memberdir/$username.siz"); }
	if(-e "$memberdir/$username.pop") {
		unlink("$memberdir/$username.pop");
	}
	                unlink("$memberdir/$username.yam");
			if(-e "$memberdir/$username.bud") {
	                unlink("$memberdir/$username.bud");
			}
	                unlink("$memberdir/$username.ll");
	                unlink("$memberdir/$username.buddy");
	                unlink("$memberdir/$username.storage");
		}

		opendir (DIRECTORY,"$datadir");
		@dirdata = readdir(DIRECTORY);
		closedir (DIRECTORY);

		if($settings[7] eq 'Administrator') {
			$umail=$member{'email'};
		} else {
			$umail=$settings[2];
		}
		foreach $filename (@dirdata) {
			unless( $filename =~ m~mail\A~ ) { next; }
			fopen(FILE, "$datadir/$filename");
			@entries = <FILE>;
			fclose(FILE);

			fopen(FILE, ">$datadir/$filename");
			foreach $entry (@entries) {
				$entry =~ s/[\n\r]//g;
				if ($entry ne $umail) {
					print FILE "$entry\n";
				}
			}
			fclose(FILE);

		}

		fopen(FILE, "$memberdir/memberlist.txt");
		@members = <FILE>;
		fclose(FILE);
		fopen(FILE, ">$memberdir/memberlist.txt", 1);
		my $memberfound = 0;
		my $lastvalidmember = '';
		foreach $curmem (@members) {
			chomp $curmem;
			if($curmem ne $member{'username'}) { print FILE "$curmem\n"; $lastvalidmember = $curmem; }
			else { ++$memberfound; }
		}
		fclose(FILE);
		my $membershiptotal = @members - $memberfound;
		fopen(FILE, "+>$memberdir/members.ttl");
		print FILE qq~$membershiptotal|$lastvalidmember~;
		fclose(FILE);
		if($settings[7] ne 'Administrator') {
			require "$sourcedir/LogInOut.pl"; &Logout;
		}
		$yySetLocation = qq~$scripturl~;
		&redirectexit;
	}
	else { &fatal_error("$txt{'751'}"); }
	}
	exit;
}


sub DelTemp {
	opendir(DIR,$boarddir) || die "$boarddir: $!";
	my @Clean = readdir(DIR);
	closedir(DIR);
	foreach(@Clean) { if($_ =~ /^CGItemp/) { unlink("$boarddir/$_"); } }
}

sub UploadAvatar {
	if(!$allowuplava) { &fatal_error($uplavatxt{'8'}); }

	if ($INFO{'username'} =~ m~/~){ &fatal_error($txt{'224'}); }
	if ($INFO{'username'} =~ m~\\~){ &fatal_error($txt{'225'}); }
	if($username ne $INFO{'username'} && $settings[7] ne 'Administrator') { &fatal_error($txt{'80'}); }
	if(!-e ("$memberdir/$INFO{'username'}.dat")){ &fatal_error("$txt{'453'} -- $INFO{'username'}"); }
	if($allowpics) {
		opendir(DIR, "$facesdir") || fatal_error("$txt{'230'} ($facesdir)! $txt{'681'}");
		closedir(DIR);
	}

	$yymain .= qq~
<form action="$cgi;action=uploadavatar2;username=$INFO{'username'}" method="POST" enctype="multipart/form-data" name="avatarupload">
<table border=0 width=720 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" height="30">
    &nbsp;<img src="$imagesdir/profile.gif" alt="" border="0">&nbsp;
    <font size=2 class="text1" color="$color{'titletext'}"><b>$uplavatxt{'1'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <table border=0 width="100%" cellpadding="3">
      <tr>
	<td><font size="2"><B>$uplavatxt{'1'}:</B></font><br><font size="1">$uplavatxt{'2'} <b>$uplavasize kB</b>.</font></td>
	<td valign="top"><input type="file" name="umafile" size="37"></td>
      </tr>
    </table><BR>
    </td>
  </tr><tr>
    <td class="catbg" bgcolor="$color{'catbg'}" height="25" align="center"><font size=2><BR>
    <input type=submit name=moda value="$uplavatxt{'1'}"><BR><BR>
    </font></td>
  </tr>
</table>
</form>
~;
	$yytitle = $uplavatxt{'1'};
	&template;
	exit;
}

sub UploadAvatar2 {
	if(!$allowuplava) { &fatal_error($uplavatxt{'8'}); }

	# make sure this person has access to this profile
	if($username ne $INFO{'username'} && $settings[7] ne 'Administrator') { &fatal_error($uplavatxt{'7'}); }

	my $unm=$INFO{'username'};

	if(-e "$umauploaddir/$unm.jpg" || -e "$umauploaddir/$unm.gif" || -e "$umauploaddir/$unm.png") { unlink("$umauploaddir/$unm.jpg"); unlink("$umauploaddir/$unm.gif"); unlink("$umauploaddir/$unm.png"); }

	require CGI; import CGI qw(:standard);
	my $query = new CGI;

	if ($query->param('umafile')) { $avatar = $query->param('umafile'); }

	my $avat=lc($avatar);

	if($avat =~ /\.jpg$/ || $avat =~ /\.gif$/ || $avat =~ /\.png$/) {
		my $type;
		$type=substr($avat,length($avat)-4,4);
		$avafile = "$unm$type";
	}
	else { &fatal_error("$uplavatxt{'2'} $uplavasize kB"); }

	$write_file = "$umauploaddir/$avafile";

	fopen(AVADAT,">$write_file");
	binmode $avatar;
	binmode AVADAT;

	local( $/, *TMP ) ;   
	open(TMP,"$umauploaddir/$avatar");   
	$filedata = <TMP>;   
	close(TMP);   

	open(AMT,">$write_file");   
	print AMT $filedata;   
	close(AMT);   

	unlink("$umauploaddir/$avatar");   

	while (read($avatar,my $buffer,1024)) { print AVADAT $buffer; }
	fclose(AVADAT);

	my @Inf=stat("$write_file");

	if($uplavasize && $Inf[7]>$uplavasize*1024) {
		unlink("$write_file");
		fatal_error("$uplavatxt{'9'} <b>$uplavasize kB</b>.");
	}

	&DelTemp;

	fopen(FILE, ">$umauploaddir/$unm.tmp");
	print FILE "$umauploadurl/$avafile\n";
	fclose(FILE);	

	$yySetLocation = qq~$boardurl/YaBB.$yyext?board=;action=profile;username=$unm~;
	&redirectexit;
}

sub ViewProfile {
	if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
	if ($INFO{'username'} =~ /\//){ &fatal_error("$txt{'224'}" ); }
	if ($INFO{'username'} =~ /\\/){ &fatal_error("$txt{'225'}" ); }
	if(!-e ("$memberdir/$INFO{'username'}.dat")){ &fatal_error("$txt{'453'} -- $INFO{'username'}"); }

	my($memberinfo, $modify, $email, $gender, $pic);

	# get the member's info
	fopen(FILE, "$memberdir/$INFO{'username'}.dat");
	@memsettings=<FILE>;
	fclose(FILE);
	chomp @memsettings;
	fopen(NUMBERFILEREAD,"$memberdir/$INFO{'username'}.yam");
	@number = <NUMBERFILEREAD>;
	fclose(NUMBERFILEREAD);
	chomp @number;
	$icq = $memsettings[8];
	if($memsettings[4] !~ m~\Ahttp://~) { $memsettings[4] = "http://$memsettings[4]"; }
	$memsettingsd[9] = $memsettings[9]; $memsettingsd[9] =~ tr/+/ /;
	$memsettingsd[10] = $memsettings[10]; $memsettingsd[10] =~ tr/+/ /;
	$dr = "";
	if ($memsettings[14] eq "") { $dr = "$txt{'470'}"; }
	else { $dr = "$memsettings[14]"; $dr = &timeformat($dr); }
	&CalcAge("calc"); # How old is he/she?
	&CalcAge("isbday"); # is it the bday?
	if($isbday) { $isbday = "<img src=\"$imagesdir/bdaycake.gif\" width=40>"; }

	my ($msstatcount);
	$msstatcount=0;
	if ($memsettings[7]) { 
		chomp($memsettings[7]);
		if ($memsettings[7] eq "Administrator") { $memberinfo = $MemStatAdmin; }
		elsif ($memsettings[7] eq "Global Moderator") { $memberinfo = $MemStatGMod; }
		else { $memberinfo = "$memsettings[7]"; }
	} else {
	if( $memsettings[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
	while($MemStat[$msstatcount] && $MemPostNum[$msstatcount] ne "x") {
	if( $memsettings[6] >= $MemPostNum[$msstatcount] ) { $memberinfo = "$MemStat[$msstatcount]"; }
	++$msstatcount;
	}
}

	&FormatUserName($INFO{'username'});
	if ($username eq $INFO{'username'} || $settings[7] eq "Administrator") {
		$modify = qq~&#171; <a href="$cgi;action=profile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
	}
	if ($username ne $INFO{'username'} && ($settings[7] eq "Global Moderator" && $allowgmod_editprof)) {
		$modify = qq~&#171; <a href="$cgi;action=gmodeditprofile;username=$useraccount{$INFO{'username'}}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'17'}</font></a> &#187;~;
	}
	if ($memsettings[19] ne "checked" || $settings[7] eq "Administrator" || ($settings[7] eq 'Global Moderator') || !$allow_hide_email) {
		$email = qq~<a href="mailto:$memsettings[2]">$memsettings[2]</a>~;
	}
	else { $email = qq~<i>$txt{'722'}</i>~; }
	$gender = "";
	if ($memsettings[11] eq "Male") { $gender = qq~$txt{'238'}~; }
	if ($memsettings[11] eq "Female") { $gender = qq~$txt{'239'}~; }
	if($allowpics) {
	if (-e "$memberdir/$INFO{'username'}.siz") {
		fopen(IMGSIZFILEREAD,"$memberdir/$INFO{'username'}.siz");
		@imgsize = <IMGSIZFILEREAD>;
		fclose(IMGSIZFILEREAD);
		chomp @imgsize;
		$akt_width = $imgsize[0];
		$akt_height = $imgsize[1];
	}
	else {
		$akt_width = 65;
		$akt_height = 65;
	}
	if ($memsettings[13] =~ /^\http:\/\// ) {
		&set_picsize($akt_width, $akt_height, $userpic_width, $userpic_height);
		$tmp_width = "width=$akt_width";
		$tmp_height = "height=$akt_height";
		$pic = qq~<a href="$memsettings[13]" target="_blank" onClick="window.open('$memsettings[13]', 'ppic$INFO{username}', 'resizable,width=200,height=200'); return false;">~;
                $pic .= qq~<img src="$memsettings[13]" $tmp_width $tmp_height border="0" alt=""></a>~;
	}
	else {
		$pic = qq~<a href="$facesurl/$memsettings[13]" target="_blank" onClick="window.open('$facesurl/$memsettings[13]', 'ppic$INFO{username}', 'resizable,width=200,height=200'); return false;">~;
                $pic .= qq~<img src="$facesurl/$memsettings[13]" border="0" alt=""></a>~;
	}
	}

	#homepage mod - do we want a link
	if (-e("$memberdir/$INFO{'username'}.home"))
	{
		unless ($username eq 'Guest' && !$guests_view_hp)
		{
			fopen(FILE, "$memberdir/$INFO{'username'}.home"); $hp = <FILE>; fclose(FILE);
			chomp $hp;
			($junk, $junk, $hp_banned) = split(/\|/, $hp);

			if ($hp_banned) { $homepage_link = $txt{'470'}; }
			else { $homepage_link = qq~<a href="$cgi;action=hpview;member=$INFO{'username'}">$hp_txt{'20'}</a>~; }
		}
	}
	else { $homepage_link = $txt{'470'}; }
	$online = "$txt{'113'} ?";
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if($name) {
			&LoadUser($name);
			if(lc $name eq lc $INFO{'username'}) {
				$online =~ s~\?~<i>$txt{'686'}</i>.~;
			}
		}
	}
	fopen(FILE, "$memberdir/$INFO{'username'}.ll");
		my ($userlastlogin, $userlastpost, $userlastim) = <FILE>;
	fclose(FILE);
	$userlastlogin =~ s/\n//g; $userlastlogin = &timeformat($userlastlogin);
	$userlastpost =~ s/\n//g; $userlastpost = &timeformat($userlastpost);
	$userlastim =~ s/\n//g; $userlastim = &timeformat($userlastim);
	if ($userlastlogin eq "") { $userlastlogin = "$txt{'470'}"; }
	if ($userlastpost eq "") { $userlastpost = "$txt{'470'}"; }
	if ($userlastim eq "") { $userlastim = "$txt{'470'}"; }
	$online =~ s~\?~<i>$txt{'687'}</i>.~;
	if($memsettings[6] > 100000) { $memsettings[6] = "$txt{'683'}"; }
	if($username ne $INFO{'username'} && $enable_buddies) { $add2bud = qq~<BR><a href="$cgi;action=managebuddies2;addbuddies=$useraccount{$INFO{'username'}}">$imtxt{'37'}</a>.<BR><BR>~; } else { $add2bud = qq~<BR><BR>~; }

	$yymain .= qq~
<table border="0" cellpadding="4" cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" width="75%">
  <tr>
    <td class="titlebg" colspan="2" bgcolor="$color{'titlebg'}">
    <table border="0" cellspacing="0" cellpadding="0" width="100%">
      <tr height="30">
	<td width="50%">
        <img src="$imagesdir/profile.gif" alt="" border="0">&nbsp;
        <font size=2 class="text1" color="$color{'titletext'}"><B>$txt{'35'}: $INFO{'username'}</b></font></td>
	<td align="center" width="20%">
        <font size=2 class="text1" color="$color{'titletext'}">$modify</font></td>
	<td align="center" width="30%">
        <font size=2 class="text1" color="$color{'titletext'}">$txt{'232'}</font></td>
      </tr>
    </table>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}" class="windowbg" width="70%">
    <table border=0 cellspacing="0" cellpadding="2" width="100%">
      <tr>
	<td><font size=2><b>$txt{'68'}: </b></font></td>
	<td><font size=2>$memsettings[1]</font></td>
      </tr><tr>
	~;
	if ($view_numb) {
		if ($number[0] > 0) {
		$yymain .= qq~
		<td><font size=2><b>$membtxt{'24'}: </b></font></td>
		<td><font size=2>$number[0]</font></td>
	      </tr><tr>
		~;
		}
	}
	$yymain .= qq~
        <td><font size=2><b>$txt{'86'}: </b></font></td>
        <td><font size=2>$memsettings[6]</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'87'}: </b></font></td>
        <td><font size=2>$memberinfo</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'233'}: </b></font></td>
        <td><font size=2>$dr</font></td>
	~;
	if ($settings[7] eq "Administrator" || $settings[7] eq "Global Moderator" && $allow_mod == 1) {
		my ($ipnumb1, $ipnumb2, $ipnumb3) =  split(/\|/, $number[1]);
		if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
		else {
			$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
			if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
			if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
		}
	$yymain .= qq~
	      </tr><tr>
		<td colspan="2"><hr size="1" width="100%" class="hr"></td>
	      </tr><tr>
	        <td valign=top><font size=2><b>$membtxt{'30'}: </b></font></td>
	        <td valign=top><font size=2>$viewipnumb</font></td>
	~;
	}
	$yymain .= qq~
~;
	if( $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
	$yymain .= qq~
      </tr><tr>
	~;
	if(-e ("$memberdir/$INFO{'username'}.mim")) {
		fopen(FILE,"$memberdir/$INFO{'username'}.mim");
		@mymood = <FILE>;
		fclose(FILE);
		chomp $mymood;
		$thistime = time;
		if(($thistime-$mymood[1]) < 86400) {
			$moodgif = qq~<img src="$imagesdir/$mymood[0].gif" height="60" width="60" border="0" alt=""><br>~;
			$yymain .= qq~
			<td colspan="2"><hr size="1" width="100%" class="hr"></td>
		      </tr><tr>
		        <td><font size=2><b>$mimtxt{'02'}</b></font></td>
		        <td>$moodgif</td>
		      </tr><tr>
			~;
		}
	}
	$yymain .= qq~
        <td><font size=2><b>$amv_txt{'9'}: </b></font></td>
        <td><font size=2>$userlastlogin</font></td>
      </tr><tr>
        <td><font size=2><b>$amv_txt{'10'}: </b></font></td>
        <td><font size=2>$userlastpost</font></td>
      </tr><tr>
        <td><font size=2><b>$amv_txt{'11'}: </b></font></td>
        <td><font size=2>$userlastim</font></td>
~;
}
	$yymain .= qq~
      </tr><tr>
	<td colspan="2"><hr size="1" width="100%" class="hr"></td>
      </tr><tr>
        <td><font size=2><b>$txt{'513'}:</b></font></td>
        <td><font size=2>~;
        if( $memsettings[8] ne "" && $memsettings[8] !~ m~\D~ ) {$yymain .= qq~ <img src="http://web.icq.com/whitepages/online?icq=$memsettings[8]&img=5" alt="$memsettings[8]" border="0"> <a href="$cgi;action=icqpager;UIN=$icq" target=_blank>$memsettings[8]</a>~;}
	$yymain .= qq~
        </font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'603'}: </b></font></td>
        <td><font size=2><a href="aim:goim?screenname=$memsettings[9]&message=Hi,+are+you+there?">$memsettingsd[9]</a></font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'604'}: </b></font></td>
        <td><font size=2>~;
        if( $memsettings[10] ne "") {$yymain .= qq~ <img src="http://opi.yahoo.com/online?u=$memsettings[10]&m=g&t=0" NOSAVE BORDER=0 alt="$memsettings[10]"> <a href="http://edit.yahoo.com/config/send_webmesg?.target=$memsettings[10]">$memsettingsd[10]</a></font></td>~;}
        else {$yymain .= qq~ </font></td>~;}
	$yymain .= qq~
      </tr><tr>
	<td><font size=2><b>$txt{'69'}: </b></font></td>
	<td><font size=2>$email</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'96'}: </b></font></td>
        <td><font size=2><a href="$memsettings[4]" target=_blank>$memsettings[3]</a></font></td>
      </tr><tr>
        <td><font size=2><b>$hp_txt{'1'}: </b></font></td>
        <td><font size=2>$homepage_link</font></td>
      </tr><tr>
	<td colspan="2"><hr size="1" width="100%" class="hr"></td>
      </tr><tr>
	<td><font size=2><b>$txt{'231'}: </b></font></td>
	<td><font size=2>$gender</font></td>
      </tr><tr>
        <td><font size=2><b>$txt{'420'}:</b></font></td>
        <td><font size=2>$age</font> &nbsp; $isbday</td>
      </tr><tr>
        <td><font size=2><b>$txt{'227'}: </b></font></td>
        <td><font size=2>$memsettings[15]</font></td>
      </tr>
    </table>
    </td>
    <td bgcolor="$color{'windowbg'}" class="windowbg" valign="middle" align="center" width="30%">
    $pic<BR><BR>
    <font size=1>$memsettings[12]</font><br><br>
	~;
		if($username ne "Guest") {
			require "$sourcedir/LevelMeter.pl";
			if($view_in_profile) { &LevelMeter($INFO{'username'},0,0,0); }
		}
	$yymain .= qq~
	</td>
  </tr><tr height="25">
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">
    &nbsp;<font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'459'}:</b></font></td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" width="100%">
    <form action="$cgi;action=usersrecentposts;username=$useraccount{$INFO{'username'}}" method="POST">
    <font size=2>
    $online<br><br><a href="$scripturl?action=travelmap4;tmapusername=$INFO{'username'}">$TravelMaptxt{'03'} $memsettings[1]</a><br><br>
    <a href="$cgi;action=imsend;to=$useraccount{$INFO{'username'}}">$txt{'688'}</a>.
    $add2bud
    $txt{'460'} <select name="viewscount" size="1">
     <option value="5">5</option>
     <option value="10" selected>10</option>
     <option value="50">50</option>
     <option value="0">$txt{'190'}</option>
    </select> $txt{'461'}. <input type="submit" value="$txt{'462'}">
    </font></form></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'92'} $INFO{'username'}";
	&template;
	exit;
}

sub usersrecentposts {
	my $curuser = $INFO{'username'};
	&FormatUserName($curuser);
	if ($curuser =~ m~/~){ &fatal_error($txt{'224'}); }
	if ($curuser =~ m~\\~){ &fatal_error($txt{'225'}); }
	my $display = $FORM{'viewscount'};
	if( $display =~ /\D/ ) { &fatal_error($txt{'337'}); }
	$display ||= 999999999;
	my( @memset, @categories, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, $tmpa, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );

	fopen(FILE, "$memberdir/$curuser.dat") || &fatal_error("$txt{'23'} $curuser.txt");
	@memset = <FILE>;
	fclose(FILE);

	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	&LoadCensorList;	# Load Censor List

	$oldestfound = stringtotime("01/10/37 $txt{'107'} 00:00:00");

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		$openmemgr{$curcat} = 0;
		my($mscount);
		$mscount=0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		foreach $tmpa (@membergroups) {
		$tmpa =~ s/\n//g;
			if( $settings[7] eq "$tmpa") { $openmemgr{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if( $settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") {
	$memberinfo = "$MemStat[$mscount]"; }
	++$mscount;
	}
	if ( $memberinfo eq $tmpa ) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }

		boardcheck: foreach $curboard (@{$catboards{$curcat}}) {
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			threadcheck: for ($i = 0; $i < @threads; $i++) {
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				fopen(FILE, "$datadir/$tnum.txt") || next;
				@messages = <FILE>;
				fclose(FILE);

				for ($c = 0; $c < @messages; $c++) {
					chomp $messages[$c];
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$messages[$c]);
					if ($curuser eq $musername) {
						$mtime = stringtotime($mdate);
						if( $numfound >= $display && $mtime <= $oldestfound ) {
							next boardcheck;
						}
						else {
							$data{$mtime} = [$curboard, $tnum, $c, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns];
							if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
							++$numfound;
						}
					}
				}
			}
		}
	}

	$yymain .= qq~
<p align=left><a href="$cgi;action=viewprofile;username=$useraccount{$curuser}"><font size=2><b>$txt{'92'} $memset[1]</b></font></a></p>
~;
	@messages = sort {$b <=> $a } keys %data;
	if( @messages > $display ) { $#messages = $display - 1; }
	$counter = 1;
	for( $i = 0; $i < @messages; $i++ ) {
		($board, $tnum, $c, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = @{ $data{$messages[$i]} };
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

#### Remove excessive line returns mod
	while ($message =~ m~<br>[(/&nbsp/;)\s]*<br>[(/&nbsp/;)\s]*<br>~i) {
		$message =~ s~<br>[(/&nbsp/;)\s]*<br>[(/&nbsp/;)\s]*<br>~<br><br>~ig;
	}
####

		&wrap;
		$displayname = $mname;
		if($enable_ubbc) { $ns = $mns; if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		if($enable_notification) { $notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum;start=$c">$img{'notify'}</a>~; }
		$mdate = timeformat($mdate);
		$yymain .= qq~
<table border="0" width="100%" cellspacing="1" $color{'bordercolor'}>
  <tr>
    <td align="left" bgcolor="$color{'titlebg'}" class="titlebg"><font class="text1" color="$color{'titletext'}" size="2">&nbsp;$counter&nbsp;</font></td>
    <td width="75%" bgcolor="$color{'titlebg'}" class="titlebg"><font class="text1" color="$color{'titletext'}" size="2"><b>&nbsp;$catname{$cat{$board}} / $boardinfo{$board}->[0] / <a href="$scripturl?board=$board;action=display;num=$tnum;start=$c#$c"><font class="text1" color="$color{'titletext'}" size=2><u>$msub</u></font></a></b></font></td>
    <td align="right" bgcolor="$color{'titlebg'}" class="titlebg" nowrap>&nbsp;<font class="text1" color="$color{'titletext'}" size=2>$mdate&nbsp;</font></td>
  </tr><tr height=80>
    <td colspan="3" bgcolor="$color{'windowbg2'}"  class="windowbg2" valign="top"><font size="2">$message</font></td>
  </tr><tr>
    <td colspan="3" bgcolor="$color{'catbg'}" class="catbg"><font size="2">
    &nbsp;<a href="$scripturl?board=$board;action=post;num=$tnum;start=$c;title=Post+reply">$img{'reply'}</a>$menusep<a href="$scripturl?board=$board;action=post;num=$tnum;quote=$c;title=Post+reply">$img{'replyquote2'}</a>$notify
    </font></td>
  </tr>
</table><br>
~;
		++$counter;
	}
if($counter <= 1) { $yymain .= "<font size=2><B>$txt{'755'}</B></font>"; }
else { $yymain .= qq~
<p align=left><a href="$cgi;action=viewprofile;username=$useraccount{$curuser}"><font size=2><b>$txt{'92'} $memset[1]</b></font></a></p></font>
~; }
	$yytitle = "$txt{'458'} $memset[1]";
	&template;
	exit;
}

1;